#ifndef TRACE_H
#define TRACE_H

/* This file is autogenerated by tracetool, do not edit. */

#include "qemu-common.h"
#include "trace-dtrace.h"

static inline void trace_qemu_malloc(size_t size, void *ptr) {
    if (QEMU_QEMU_MALLOC_ENABLED()) {
        QEMU_QEMU_MALLOC(size, ptr);
    }
}

static inline void trace_qemu_realloc(void *ptr, size_t size, void *newptr) {
    if (QEMU_QEMU_REALLOC_ENABLED()) {
        QEMU_QEMU_REALLOC(ptr, size, newptr);
    }
}

static inline void trace_qemu_free(void *ptr) {
    if (QEMU_QEMU_FREE_ENABLED()) {
        QEMU_QEMU_FREE(ptr);
    }
}

static inline void trace_qemu_memalign(size_t alignment, size_t size, void *ptr) {
    if (QEMU_QEMU_MEMALIGN_ENABLED()) {
        QEMU_QEMU_MEMALIGN(alignment, size, ptr);
    }
}

static inline void trace_qemu_vmalloc(size_t size, void *ptr) {
    if (QEMU_QEMU_VMALLOC_ENABLED()) {
        QEMU_QEMU_VMALLOC(size, ptr);
    }
}

static inline void trace_qemu_vfree(void *ptr) {
    if (QEMU_QEMU_VFREE_ENABLED()) {
        QEMU_QEMU_VFREE(ptr);
    }
}

static inline void trace_virtqueue_fill(void *vq, const void *elem, unsigned int len, unsigned int idx) {
    if (QEMU_VIRTQUEUE_FILL_ENABLED()) {
        QEMU_VIRTQUEUE_FILL(vq, elem, len, idx);
    }
}

static inline void trace_virtqueue_flush(void *vq, unsigned int count) {
    if (QEMU_VIRTQUEUE_FLUSH_ENABLED()) {
        QEMU_VIRTQUEUE_FLUSH(vq, count);
    }
}

static inline void trace_virtqueue_pop(void *vq, void *elem, unsigned int in_num, unsigned int out_num) {
    if (QEMU_VIRTQUEUE_POP_ENABLED()) {
        QEMU_VIRTQUEUE_POP(vq, elem, in_num, out_num);
    }
}

static inline void trace_virtio_queue_notify(void *vdev, int n, void *vq) {
    if (QEMU_VIRTIO_QUEUE_NOTIFY_ENABLED()) {
        QEMU_VIRTIO_QUEUE_NOTIFY(vdev, n, vq);
    }
}

static inline void trace_virtio_irq(void *vq) {
    if (QEMU_VIRTIO_IRQ_ENABLED()) {
        QEMU_VIRTIO_IRQ(vq);
    }
}

static inline void trace_virtio_notify(void *vdev, void *vq) {
    if (QEMU_VIRTIO_NOTIFY_ENABLED()) {
        QEMU_VIRTIO_NOTIFY(vdev, vq);
    }
}

static inline void trace_virtio_console_flush_buf(unsigned int port, size_t len, ssize_t ret) {
    if (QEMU_VIRTIO_CONSOLE_FLUSH_BUF_ENABLED()) {
        QEMU_VIRTIO_CONSOLE_FLUSH_BUF(port, len, ret);
    }
}

static inline void trace_virtio_console_chr_read(unsigned int port, int size) {
    if (QEMU_VIRTIO_CONSOLE_CHR_READ_ENABLED()) {
        QEMU_VIRTIO_CONSOLE_CHR_READ(port, size);
    }
}

static inline void trace_virtio_console_chr_event(unsigned int port, int event) {
    if (QEMU_VIRTIO_CONSOLE_CHR_EVENT_ENABLED()) {
        QEMU_VIRTIO_CONSOLE_CHR_EVENT(port, event);
    }
}

static inline void trace_multiwrite_cb(void *mcb, int ret) {
    if (QEMU_MULTIWRITE_CB_ENABLED()) {
        QEMU_MULTIWRITE_CB(mcb, ret);
    }
}

static inline void trace_bdrv_aio_multiwrite(void *mcb, int num_callbacks, int num_reqs) {
    if (QEMU_BDRV_AIO_MULTIWRITE_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE(mcb, num_callbacks, num_reqs);
    }
}

static inline void trace_bdrv_aio_multiwrite_earlyfail(void *mcb) {
    if (QEMU_BDRV_AIO_MULTIWRITE_EARLYFAIL_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE_EARLYFAIL(mcb);
    }
}

static inline void trace_bdrv_aio_multiwrite_latefail(void *mcb, int i) {
    if (QEMU_BDRV_AIO_MULTIWRITE_LATEFAIL_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE_LATEFAIL(mcb, i);
    }
}

static inline void trace_bdrv_aio_discard(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_DISCARD_ENABLED()) {
        QEMU_BDRV_AIO_DISCARD(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_flush(void *bs, void *opaque) {
    if (QEMU_BDRV_AIO_FLUSH_ENABLED()) {
        QEMU_BDRV_AIO_FLUSH(bs, opaque);
    }
}

static inline void trace_bdrv_aio_readv(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_READV_ENABLED()) {
        QEMU_BDRV_AIO_READV(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_writev(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_WRITEV_ENABLED()) {
        QEMU_BDRV_AIO_WRITEV(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_lock_medium(void *bs, int locked) {
    if (QEMU_BDRV_LOCK_MEDIUM_ENABLED()) {
        QEMU_BDRV_LOCK_MEDIUM(bs, locked);
    }
}

static inline void trace_bdrv_co_readv(void *bs, int64_t sector_num, int nb_sector) {
    if (QEMU_BDRV_CO_READV_ENABLED()) {
        QEMU_BDRV_CO_READV(bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_writev(void *bs, int64_t sector_num, int nb_sector) {
    if (QEMU_BDRV_CO_WRITEV_ENABLED()) {
        QEMU_BDRV_CO_WRITEV(bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_write_zeroes(void *bs, int64_t sector_num, int nb_sector) {
    if (QEMU_BDRV_CO_WRITE_ZEROES_ENABLED()) {
        QEMU_BDRV_CO_WRITE_ZEROES(bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_io_em(void *bs, int64_t sector_num, int nb_sectors, int is_write, void *acb) {
    if (QEMU_BDRV_CO_IO_EM_ENABLED()) {
        QEMU_BDRV_CO_IO_EM(bs, sector_num, nb_sectors, is_write, acb);
    }
}

static inline void trace_bdrv_co_copy_on_readv(void *bs, int64_t sector_num, int nb_sector) {
    if (QEMU_BDRV_CO_COPY_ON_READV_ENABLED()) {
        QEMU_BDRV_CO_COPY_ON_READV(bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_do_copy_on_readv(void *bs, int64_t sector_num, int nb_sectors, int64_t cluster_sector_num, int cluster_nb_sectors) {
    if (QEMU_BDRV_CO_DO_COPY_ON_READV_ENABLED()) {
        QEMU_BDRV_CO_DO_COPY_ON_READV(bs, sector_num, nb_sectors, cluster_sector_num, cluster_nb_sectors);
    }
}

static inline void trace_mirror_one_iteration(void *s, int64_t sector_num) {
    if (QEMU_MIRROR_ONE_ITERATION_ENABLED()) {
        QEMU_MIRROR_ONE_ITERATION(s, sector_num);
    }
}

static inline void trace_mirror_start(void *bs, void *s, void *co, void *opaque) {
    if (QEMU_MIRROR_START_ENABLED()) {
        QEMU_MIRROR_START(bs, s, co, opaque);
    }
}

static inline void trace_mirror_restart_iter(void *s, int64_t cnt) {
    if (QEMU_MIRROR_RESTART_ITER_ENABLED()) {
        QEMU_MIRROR_RESTART_ITER(s, cnt);
    }
}

static inline void trace_stream_one_iteration(void *s, int64_t sector_num, int nb_sectors, int is_allocated) {
    if (QEMU_STREAM_ONE_ITERATION_ENABLED()) {
        QEMU_STREAM_ONE_ITERATION(s, sector_num, nb_sectors, is_allocated);
    }
}

static inline void trace_stream_start(void *bs, void *base, void *s, void *co, void *opaque) {
    if (QEMU_STREAM_START_ENABLED()) {
        QEMU_STREAM_START(bs, base, s, co, opaque);
    }
}

static inline void trace_commit_one_iteration(void *s, int64_t sector_num, int nb_sectors, int is_allocated) {
    if (QEMU_COMMIT_ONE_ITERATION_ENABLED()) {
        QEMU_COMMIT_ONE_ITERATION(s, sector_num, nb_sectors, is_allocated);
    }
}

static inline void trace_commit_start(void *bs, void *base, void *top, void *s, void *co, void *opaque) {
    if (QEMU_COMMIT_START_ENABLED()) {
        QEMU_COMMIT_START(bs, base, top, s, co, opaque);
    }
}

static inline void trace_do_block_job_cancel(void *job) {
    if (QEMU_DO_BLOCK_JOB_CANCEL_ENABLED()) {
        QEMU_DO_BLOCK_JOB_CANCEL(job);
    }
}

static inline void trace_block_job_cb(void *bs, void *job, int ret) {
    if (QEMU_BLOCK_JOB_CB_ENABLED()) {
        QEMU_BLOCK_JOB_CB(bs, job, ret);
    }
}

static inline void trace_do_block_stream(void *bs, void *job) {
    if (QEMU_DO_BLOCK_STREAM_ENABLED()) {
        QEMU_DO_BLOCK_STREAM(bs, job);
    }
}

static inline void trace_virtio_blk_req_complete(void *req, int status) {
    if (QEMU_VIRTIO_BLK_REQ_COMPLETE_ENABLED()) {
        QEMU_VIRTIO_BLK_REQ_COMPLETE(req, status);
    }
}

static inline void trace_virtio_blk_rw_complete(void *req, int ret) {
    if (QEMU_VIRTIO_BLK_RW_COMPLETE_ENABLED()) {
        QEMU_VIRTIO_BLK_RW_COMPLETE(req, ret);
    }
}

static inline void trace_virtio_blk_handle_write(void *req, uint64_t sector, size_t nsectors) {
    if (QEMU_VIRTIO_BLK_HANDLE_WRITE_ENABLED()) {
        QEMU_VIRTIO_BLK_HANDLE_WRITE(req, sector, nsectors);
    }
}

static inline void trace_paio_submit(void *acb, void *opaque, int64_t sector_num, int nb_sectors, int type) {
    if (QEMU_PAIO_SUBMIT_ENABLED()) {
        QEMU_PAIO_SUBMIT(acb, opaque, sector_num, nb_sectors, type);
    }
}

static inline void trace_cpu_in(unsigned int addr, unsigned int val) {
    if (QEMU_CPU_IN_ENABLED()) {
        QEMU_CPU_IN(addr, val);
    }
}

static inline void trace_cpu_out(unsigned int addr, unsigned int val) {
    if (QEMU_CPU_OUT_ENABLED()) {
        QEMU_CPU_OUT(addr, val);
    }
}

static inline void trace_balloon_event(void *opaque, unsigned long addr) {
    if (QEMU_BALLOON_EVENT_ENABLED()) {
        QEMU_BALLOON_EVENT(opaque, addr);
    }
}

static inline void trace_virtio_blk_data_plane_start(void *s) {
    if (QEMU_VIRTIO_BLK_DATA_PLANE_START_ENABLED()) {
        QEMU_VIRTIO_BLK_DATA_PLANE_START(s);
    }
}

static inline void trace_virtio_blk_data_plane_stop(void *s) {
    if (QEMU_VIRTIO_BLK_DATA_PLANE_STOP_ENABLED()) {
        QEMU_VIRTIO_BLK_DATA_PLANE_STOP(s);
    }
}

static inline void trace_virtio_blk_data_plane_process_request(void *s, unsigned int out_num, unsigned int in_num, unsigned int head) {
    if (QEMU_VIRTIO_BLK_DATA_PLANE_PROCESS_REQUEST_ENABLED()) {
        QEMU_VIRTIO_BLK_DATA_PLANE_PROCESS_REQUEST(s, out_num, in_num, head);
    }
}

static inline void trace_virtio_blk_data_plane_complete_request(void *s, unsigned int head, int ret) {
    if (QEMU_VIRTIO_BLK_DATA_PLANE_COMPLETE_REQUEST_ENABLED()) {
        QEMU_VIRTIO_BLK_DATA_PLANE_COMPLETE_REQUEST(s, head, ret);
    }
}

static inline void trace_vring_setup(uint64_t physical, void *desc, void *avail, void *used) {
    if (QEMU_VRING_SETUP_ENABLED()) {
        QEMU_VRING_SETUP(physical, desc, avail, used);
    }
}

static inline void trace_apic_local_deliver(int vector, uint32_t lvt) {
    if (QEMU_APIC_LOCAL_DELIVER_ENABLED()) {
        QEMU_APIC_LOCAL_DELIVER(vector, lvt);
    }
}

static inline void trace_apic_deliver_irq(uint8_t dest, uint8_t dest_mode, uint8_t delivery_mode, uint8_t vector_num, uint8_t polarity, uint8_t trigger_mode) {
    if (QEMU_APIC_DELIVER_IRQ_ENABLED()) {
        QEMU_APIC_DELIVER_IRQ(dest, dest_mode, delivery_mode, vector_num, polarity, trigger_mode);
    }
}

static inline void trace_cpu_set_apic_base(uint64_t val) {
    if (QEMU_CPU_SET_APIC_BASE_ENABLED()) {
        QEMU_CPU_SET_APIC_BASE(val);
    }
}

static inline void trace_cpu_get_apic_base(uint64_t val) {
    if (QEMU_CPU_GET_APIC_BASE_ENABLED()) {
        QEMU_CPU_GET_APIC_BASE(val);
    }
}

static inline void trace_apic_mem_readl(uint64_t addr, uint32_t val) {
    if (QEMU_APIC_MEM_READL_ENABLED()) {
        QEMU_APIC_MEM_READL(addr, val);
    }
}

static inline void trace_apic_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_APIC_MEM_WRITEL_ENABLED()) {
        QEMU_APIC_MEM_WRITEL(addr, val);
    }
}

static inline void trace_apic_reset_irq_delivered(int apic_irq_delivered) {
    if (QEMU_APIC_RESET_IRQ_DELIVERED_ENABLED()) {
        QEMU_APIC_RESET_IRQ_DELIVERED(apic_irq_delivered);
    }
}

static inline void trace_apic_get_irq_delivered(int apic_irq_delivered) {
    if (QEMU_APIC_GET_IRQ_DELIVERED_ENABLED()) {
        QEMU_APIC_GET_IRQ_DELIVERED(apic_irq_delivered);
    }
}

static inline void trace_apic_set_irq(int apic_irq_delivered) {
    if (QEMU_APIC_SET_IRQ_ENABLED()) {
        QEMU_APIC_SET_IRQ(apic_irq_delivered);
    }
}

static inline void trace_usb_port_claim(int bus, const char *port) {
    if (QEMU_USB_PORT_CLAIM_ENABLED()) {
        QEMU_USB_PORT_CLAIM(bus, port);
    }
}

static inline void trace_usb_port_attach(int bus, const char *port) {
    if (QEMU_USB_PORT_ATTACH_ENABLED()) {
        QEMU_USB_PORT_ATTACH(bus, port);
    }
}

static inline void trace_usb_port_detach(int bus, const char *port) {
    if (QEMU_USB_PORT_DETACH_ENABLED()) {
        QEMU_USB_PORT_DETACH(bus, port);
    }
}

static inline void trace_usb_port_release(int bus, const char *port) {
    if (QEMU_USB_PORT_RELEASE_ENABLED()) {
        QEMU_USB_PORT_RELEASE(bus, port);
    }
}

static inline void trace_usb_ehci_reset(void) {
    if (QEMU_USB_EHCI_RESET_ENABLED()) {
        QEMU_USB_EHCI_RESET();
    }
}

static inline void trace_usb_ehci_mmio_readl(uint32_t addr, const char *str, uint32_t val) {
    if (QEMU_USB_EHCI_MMIO_READL_ENABLED()) {
        QEMU_USB_EHCI_MMIO_READL(addr, str, val);
    }
}

static inline void trace_usb_ehci_mmio_writel(uint32_t addr, const char *str, uint32_t val) {
    if (QEMU_USB_EHCI_MMIO_WRITEL_ENABLED()) {
        QEMU_USB_EHCI_MMIO_WRITEL(addr, str, val);
    }
}

static inline void trace_usb_ehci_mmio_change(uint32_t addr, const char *str, uint32_t new, uint32_t old) {
    if (QEMU_USB_EHCI_MMIO_CHANGE_ENABLED()) {
        QEMU_USB_EHCI_MMIO_CHANGE(addr, str, new, old);
    }
}

static inline void trace_usb_ehci_usbsts(const char *sts, int state) {
    if (QEMU_USB_EHCI_USBSTS_ENABLED()) {
        QEMU_USB_EHCI_USBSTS(sts, state);
    }
}

static inline void trace_usb_ehci_state(const char *schedule, const char *state) {
    if (QEMU_USB_EHCI_STATE_ENABLED()) {
        QEMU_USB_EHCI_STATE(schedule, state);
    }
}

static inline void trace_usb_ehci_qh_ptrs(void *q, uint32_t addr, uint32_t nxt, uint32_t c_qtd, uint32_t n_qtd, uint32_t a_qtd) {
    if (QEMU_USB_EHCI_QH_PTRS_ENABLED()) {
        QEMU_USB_EHCI_QH_PTRS(q, addr, nxt, c_qtd, n_qtd, a_qtd);
    }
}

static inline void trace_usb_ehci_qh_fields(uint32_t addr, int rl, int mplen, int eps, int ep, int devaddr) {
    if (QEMU_USB_EHCI_QH_FIELDS_ENABLED()) {
        QEMU_USB_EHCI_QH_FIELDS(addr, rl, mplen, eps, ep, devaddr);
    }
}

static inline void trace_usb_ehci_qh_bits(uint32_t addr, int c, int h, int dtc, int i) {
    if (QEMU_USB_EHCI_QH_BITS_ENABLED()) {
        QEMU_USB_EHCI_QH_BITS(addr, c, h, dtc, i);
    }
}

static inline void trace_usb_ehci_qtd_ptrs(void *q, uint32_t addr, uint32_t nxt, uint32_t altnext) {
    if (QEMU_USB_EHCI_QTD_PTRS_ENABLED()) {
        QEMU_USB_EHCI_QTD_PTRS(q, addr, nxt, altnext);
    }
}

static inline void trace_usb_ehci_qtd_fields(uint32_t addr, int tbytes, int cpage, int cerr, int pid) {
    if (QEMU_USB_EHCI_QTD_FIELDS_ENABLED()) {
        QEMU_USB_EHCI_QTD_FIELDS(addr, tbytes, cpage, cerr, pid);
    }
}

static inline void trace_usb_ehci_qtd_bits(uint32_t addr, int ioc, int active, int halt, int babble, int xacterr) {
    if (QEMU_USB_EHCI_QTD_BITS_ENABLED()) {
        QEMU_USB_EHCI_QTD_BITS(addr, ioc, active, halt, babble, xacterr);
    }
}

static inline void trace_usb_ehci_itd(uint32_t addr, uint32_t nxt, uint32_t mplen, uint32_t mult, uint32_t ep, uint32_t devaddr) {
    if (QEMU_USB_EHCI_ITD_ENABLED()) {
        QEMU_USB_EHCI_ITD(addr, nxt, mplen, mult, ep, devaddr);
    }
}

static inline void trace_usb_ehci_port_attach(uint32_t port, const char *device) {
    if (QEMU_USB_EHCI_PORT_ATTACH_ENABLED()) {
        QEMU_USB_EHCI_PORT_ATTACH(port, device);
    }
}

static inline void trace_usb_ehci_port_detach(uint32_t port) {
    if (QEMU_USB_EHCI_PORT_DETACH_ENABLED()) {
        QEMU_USB_EHCI_PORT_DETACH(port);
    }
}

static inline void trace_usb_ehci_port_reset(uint32_t port, int enable) {
    if (QEMU_USB_EHCI_PORT_RESET_ENABLED()) {
        QEMU_USB_EHCI_PORT_RESET(port, enable);
    }
}

static inline void trace_usb_ehci_data(int rw, uint32_t cpage, uint32_t offset, uint32_t addr, uint32_t len, uint32_t bufpos) {
    if (QEMU_USB_EHCI_DATA_ENABLED()) {
        QEMU_USB_EHCI_DATA(rw, cpage, offset, addr, len, bufpos);
    }
}

static inline void trace_usb_ehci_queue_action(void *q, const char *action) {
    if (QEMU_USB_EHCI_QUEUE_ACTION_ENABLED()) {
        QEMU_USB_EHCI_QUEUE_ACTION(q, action);
    }
}

static inline void trace_usb_desc_device(int addr, int len, int ret) {
    if (QEMU_USB_DESC_DEVICE_ENABLED()) {
        QEMU_USB_DESC_DEVICE(addr, len, ret);
    }
}

static inline void trace_usb_desc_device_qualifier(int addr, int len, int ret) {
    if (QEMU_USB_DESC_DEVICE_QUALIFIER_ENABLED()) {
        QEMU_USB_DESC_DEVICE_QUALIFIER(addr, len, ret);
    }
}

static inline void trace_usb_desc_config(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_CONFIG_ENABLED()) {
        QEMU_USB_DESC_CONFIG(addr, index, len, ret);
    }
}

static inline void trace_usb_desc_other_speed_config(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_OTHER_SPEED_CONFIG_ENABLED()) {
        QEMU_USB_DESC_OTHER_SPEED_CONFIG(addr, index, len, ret);
    }
}

static inline void trace_usb_desc_string(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_STRING_ENABLED()) {
        QEMU_USB_DESC_STRING(addr, index, len, ret);
    }
}

static inline void trace_usb_desc_msos(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_MSOS_ENABLED()) {
        QEMU_USB_DESC_MSOS(addr, index, len, ret);
    }
}

static inline void trace_usb_set_addr(int addr) {
    if (QEMU_USB_SET_ADDR_ENABLED()) {
        QEMU_USB_SET_ADDR(addr);
    }
}

static inline void trace_usb_set_config(int addr, int config, int ret) {
    if (QEMU_USB_SET_CONFIG_ENABLED()) {
        QEMU_USB_SET_CONFIG(addr, config, ret);
    }
}

static inline void trace_usb_clear_device_feature(int addr, int feature, int ret) {
    if (QEMU_USB_CLEAR_DEVICE_FEATURE_ENABLED()) {
        QEMU_USB_CLEAR_DEVICE_FEATURE(addr, feature, ret);
    }
}

static inline void trace_usb_set_device_feature(int addr, int feature, int ret) {
    if (QEMU_USB_SET_DEVICE_FEATURE_ENABLED()) {
        QEMU_USB_SET_DEVICE_FEATURE(addr, feature, ret);
    }
}

static inline void trace_usb_host_parse_device(int bus, int addr, int vendor, int product) {
    if (QEMU_USB_HOST_PARSE_DEVICE_ENABLED()) {
        QEMU_USB_HOST_PARSE_DEVICE(bus, addr, vendor, product);
    }
}

static inline void trace_usb_host_parse_config(int bus, int addr, int value, int active) {
    if (QEMU_USB_HOST_PARSE_CONFIG_ENABLED()) {
        QEMU_USB_HOST_PARSE_CONFIG(bus, addr, value, active);
    }
}

static inline void trace_usb_host_parse_interface(int bus, int addr, int num, int alt, int active) {
    if (QEMU_USB_HOST_PARSE_INTERFACE_ENABLED()) {
        QEMU_USB_HOST_PARSE_INTERFACE(bus, addr, num, alt, active);
    }
}

static inline void trace_usb_host_parse_endpoint(int bus, int addr, int ep, const char *dir, const char *type, int active) {
    if (QEMU_USB_HOST_PARSE_ENDPOINT_ENABLED()) {
        QEMU_USB_HOST_PARSE_ENDPOINT(bus, addr, ep, dir, type, active);
    }
}

static inline void trace_usb_host_parse_unknown(int bus, int addr, int len, int type) {
    if (QEMU_USB_HOST_PARSE_UNKNOWN_ENABLED()) {
        QEMU_USB_HOST_PARSE_UNKNOWN(bus, addr, len, type);
    }
}

static inline void trace_usb_host_parse_error(int bus, int addr, const char *errmsg) {
    if (QEMU_USB_HOST_PARSE_ERROR_ENABLED()) {
        QEMU_USB_HOST_PARSE_ERROR(bus, addr, errmsg);
    }
}

static inline void trace_scsi_req_alloc(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_ALLOC_ENABLED()) {
        QEMU_SCSI_REQ_ALLOC(target, lun, tag);
    }
}

static inline void trace_scsi_req_data(int target, int lun, int tag, int len) {
    if (QEMU_SCSI_REQ_DATA_ENABLED()) {
        QEMU_SCSI_REQ_DATA(target, lun, tag, len);
    }
}

static inline void trace_scsi_req_data_canceled(int target, int lun, int tag, int len) {
    if (QEMU_SCSI_REQ_DATA_CANCELED_ENABLED()) {
        QEMU_SCSI_REQ_DATA_CANCELED(target, lun, tag, len);
    }
}

static inline void trace_scsi_req_dequeue(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_DEQUEUE_ENABLED()) {
        QEMU_SCSI_REQ_DEQUEUE(target, lun, tag);
    }
}

static inline void trace_scsi_req_continue(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_CONTINUE_ENABLED()) {
        QEMU_SCSI_REQ_CONTINUE(target, lun, tag);
    }
}

static inline void trace_scsi_req_parsed(int target, int lun, int tag, int cmd, int mode, int xfer) {
    if (QEMU_SCSI_REQ_PARSED_ENABLED()) {
        QEMU_SCSI_REQ_PARSED(target, lun, tag, cmd, mode, xfer);
    }
}

static inline void trace_scsi_req_parsed_lba(int target, int lun, int tag, int cmd, uint64_t lba) {
    if (QEMU_SCSI_REQ_PARSED_LBA_ENABLED()) {
        QEMU_SCSI_REQ_PARSED_LBA(target, lun, tag, cmd, lba);
    }
}

static inline void trace_scsi_req_parse_bad(int target, int lun, int tag, int cmd) {
    if (QEMU_SCSI_REQ_PARSE_BAD_ENABLED()) {
        QEMU_SCSI_REQ_PARSE_BAD(target, lun, tag, cmd);
    }
}

static inline void trace_scsi_req_build_sense(int target, int lun, int tag, int key, int asc, int ascq) {
    if (QEMU_SCSI_REQ_BUILD_SENSE_ENABLED()) {
        QEMU_SCSI_REQ_BUILD_SENSE(target, lun, tag, key, asc, ascq);
    }
}

static inline void trace_scsi_device_set_ua(int target, int lun, int key, int asc, int ascq) {
    if (QEMU_SCSI_DEVICE_SET_UA_ENABLED()) {
        QEMU_SCSI_DEVICE_SET_UA(target, lun, key, asc, ascq);
    }
}

static inline void trace_scsi_report_luns(int target, int lun, int tag) {
    if (QEMU_SCSI_REPORT_LUNS_ENABLED()) {
        QEMU_SCSI_REPORT_LUNS(target, lun, tag);
    }
}

static inline void trace_scsi_inquiry(int target, int lun, int tag, int cdb1, int cdb2) {
    if (QEMU_SCSI_INQUIRY_ENABLED()) {
        QEMU_SCSI_INQUIRY(target, lun, tag, cdb1, cdb2);
    }
}

static inline void trace_scsi_test_unit_ready(int target, int lun, int tag) {
    if (QEMU_SCSI_TEST_UNIT_READY_ENABLED()) {
        QEMU_SCSI_TEST_UNIT_READY(target, lun, tag);
    }
}

static inline void trace_scsi_request_sense(int target, int lun, int tag) {
    if (QEMU_SCSI_REQUEST_SENSE_ENABLED()) {
        QEMU_SCSI_REQUEST_SENSE(target, lun, tag);
    }
}

static inline void trace_vm_state_notify(int running, int reason) {
    if (QEMU_VM_STATE_NOTIFY_ENABLED()) {
        QEMU_VM_STATE_NOTIFY(running, reason);
    }
}

static inline void trace_runstate_set(int new_state) {
    if (QEMU_RUNSTATE_SET_ENABLED()) {
        QEMU_RUNSTATE_SET(new_state);
    }
}

static inline void trace_qemu_system_shutdown_request(void) {
    if (QEMU_QEMU_SYSTEM_SHUTDOWN_REQUEST_ENABLED()) {
        QEMU_QEMU_SYSTEM_SHUTDOWN_REQUEST();
    }
}

static inline void trace_qemu_system_powerdown_request(void) {
    if (QEMU_QEMU_SYSTEM_POWERDOWN_REQUEST_ENABLED()) {
        QEMU_QEMU_SYSTEM_POWERDOWN_REQUEST();
    }
}

static inline void trace_qed_alloc_l2_cache_entry(void *l2_cache, void *entry) {
    if (QEMU_QED_ALLOC_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_ALLOC_L2_CACHE_ENTRY(l2_cache, entry);
    }
}

static inline void trace_qed_unref_l2_cache_entry(void *entry, int ref) {
    if (QEMU_QED_UNREF_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_UNREF_L2_CACHE_ENTRY(entry, ref);
    }
}

static inline void trace_qed_find_l2_cache_entry(void *l2_cache, void *entry, uint64_t offset, int ref) {
    if (QEMU_QED_FIND_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_FIND_L2_CACHE_ENTRY(l2_cache, entry, offset, ref);
    }
}

static inline void trace_qed_read_table(void *s, uint64_t offset, void *table) {
    if (QEMU_QED_READ_TABLE_ENABLED()) {
        QEMU_QED_READ_TABLE(s, offset, table);
    }
}

static inline void trace_qed_read_table_cb(void *s, void *table, int ret) {
    if (QEMU_QED_READ_TABLE_CB_ENABLED()) {
        QEMU_QED_READ_TABLE_CB(s, table, ret);
    }
}

static inline void trace_qed_write_table(void *s, uint64_t offset, void *table, unsigned int index, unsigned int n) {
    if (QEMU_QED_WRITE_TABLE_ENABLED()) {
        QEMU_QED_WRITE_TABLE(s, offset, table, index, n);
    }
}

static inline void trace_qed_write_table_cb(void *s, void *table, int flush, int ret) {
    if (QEMU_QED_WRITE_TABLE_CB_ENABLED()) {
        QEMU_QED_WRITE_TABLE_CB(s, table, flush, ret);
    }
}

static inline void trace_qed_need_check_timer_cb(void *s) {
    if (QEMU_QED_NEED_CHECK_TIMER_CB_ENABLED()) {
        QEMU_QED_NEED_CHECK_TIMER_CB(s);
    }
}

static inline void trace_qed_start_need_check_timer(void *s) {
    if (QEMU_QED_START_NEED_CHECK_TIMER_ENABLED()) {
        QEMU_QED_START_NEED_CHECK_TIMER(s);
    }
}

static inline void trace_qed_cancel_need_check_timer(void *s) {
    if (QEMU_QED_CANCEL_NEED_CHECK_TIMER_ENABLED()) {
        QEMU_QED_CANCEL_NEED_CHECK_TIMER(s);
    }
}

static inline void trace_qed_aio_complete(void *s, void *acb, int ret) {
    if (QEMU_QED_AIO_COMPLETE_ENABLED()) {
        QEMU_QED_AIO_COMPLETE(s, acb, ret);
    }
}

static inline void trace_qed_aio_setup(void *s, void *acb, int64_t sector_num, int nb_sectors, void *opaque, int flags) {
    if (QEMU_QED_AIO_SETUP_ENABLED()) {
        QEMU_QED_AIO_SETUP(s, acb, sector_num, nb_sectors, opaque, flags);
    }
}

static inline void trace_qed_aio_next_io(void *s, void *acb, int ret, uint64_t cur_pos) {
    if (QEMU_QED_AIO_NEXT_IO_ENABLED()) {
        QEMU_QED_AIO_NEXT_IO(s, acb, ret, cur_pos);
    }
}

static inline void trace_qed_aio_read_data(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_READ_DATA_ENABLED()) {
        QEMU_QED_AIO_READ_DATA(s, acb, ret, offset, len);
    }
}

static inline void trace_qed_aio_write_data(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_WRITE_DATA_ENABLED()) {
        QEMU_QED_AIO_WRITE_DATA(s, acb, ret, offset, len);
    }
}

static inline void trace_qed_aio_write_prefill(void *s, void *acb, uint64_t start, size_t len, uint64_t offset) {
    if (QEMU_QED_AIO_WRITE_PREFILL_ENABLED()) {
        QEMU_QED_AIO_WRITE_PREFILL(s, acb, start, len, offset);
    }
}

static inline void trace_qed_aio_write_postfill(void *s, void *acb, uint64_t start, size_t len, uint64_t offset) {
    if (QEMU_QED_AIO_WRITE_POSTFILL_ENABLED()) {
        QEMU_QED_AIO_WRITE_POSTFILL(s, acb, start, len, offset);
    }
}

static inline void trace_qed_aio_write_main(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_WRITE_MAIN_ENABLED()) {
        QEMU_QED_AIO_WRITE_MAIN(s, acb, ret, offset, len);
    }
}

static inline void trace_qemu_coroutine_enter(void *from, void *to, void *opaque) {
    if (QEMU_QEMU_COROUTINE_ENTER_ENABLED()) {
        QEMU_QEMU_COROUTINE_ENTER(from, to, opaque);
    }
}

static inline void trace_qemu_coroutine_yield(void *from, void *to) {
    if (QEMU_QEMU_COROUTINE_YIELD_ENABLED()) {
        QEMU_QEMU_COROUTINE_YIELD(from, to);
    }
}

static inline void trace_qemu_coroutine_terminate(void *co) {
    if (QEMU_QEMU_COROUTINE_TERMINATE_ENABLED()) {
        QEMU_QEMU_COROUTINE_TERMINATE(co);
    }
}

static inline void trace_qemu_co_queue_next_bh(void) {
    if (QEMU_QEMU_CO_QUEUE_NEXT_BH_ENABLED()) {
        QEMU_QEMU_CO_QUEUE_NEXT_BH();
    }
}

static inline void trace_qemu_co_queue_next(void *nxt) {
    if (QEMU_QEMU_CO_QUEUE_NEXT_ENABLED()) {
        QEMU_QEMU_CO_QUEUE_NEXT(nxt);
    }
}

static inline void trace_qemu_co_mutex_lock_entry(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_LOCK_ENTRY_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_LOCK_ENTRY(mutex, self);
    }
}

static inline void trace_qemu_co_mutex_lock_return(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_LOCK_RETURN_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_LOCK_RETURN(mutex, self);
    }
}

static inline void trace_qemu_co_mutex_unlock_entry(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_UNLOCK_ENTRY_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_UNLOCK_ENTRY(mutex, self);
    }
}

static inline void trace_qemu_co_mutex_unlock_return(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_UNLOCK_RETURN_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_UNLOCK_RETURN(mutex, self);
    }
}

static inline void trace_qxl_interface_set_mm_time(int qid, uint32_t mm_time) {
    if (QEMU_QXL_INTERFACE_SET_MM_TIME_ENABLED()) {
        QEMU_QXL_INTERFACE_SET_MM_TIME(qid, mm_time);
    }
}

static inline void trace_qxl_io_write_vga(int qid, const char *mode, uint32_t addr, uint32_t val) {
    if (QEMU_QXL_IO_WRITE_VGA_ENABLED()) {
        QEMU_QXL_IO_WRITE_VGA(qid, mode, addr, val);
    }
}

static inline void trace_qxl_create_guest_primary(int qid, uint32_t width, uint32_t height, uint64_t mem, uint32_t format, uint32_t position) {
    if (QEMU_QXL_CREATE_GUEST_PRIMARY_ENABLED()) {
        QEMU_QXL_CREATE_GUEST_PRIMARY(qid, width, height, mem, format, position);
    }
}

static inline void trace_qxl_create_guest_primary_rest(int qid, int32_t stride, uint32_t type, uint32_t flags) {
    if (QEMU_QXL_CREATE_GUEST_PRIMARY_REST_ENABLED()) {
        QEMU_QXL_CREATE_GUEST_PRIMARY_REST(qid, stride, type, flags);
    }
}

static inline void trace_qxl_destroy_primary(int qid) {
    if (QEMU_QXL_DESTROY_PRIMARY_ENABLED()) {
        QEMU_QXL_DESTROY_PRIMARY(qid);
    }
}

static inline void trace_qxl_enter_vga_mode(int qid) {
    if (QEMU_QXL_ENTER_VGA_MODE_ENABLED()) {
        QEMU_QXL_ENTER_VGA_MODE(qid);
    }
}

static inline void trace_qxl_exit_vga_mode(int qid) {
    if (QEMU_QXL_EXIT_VGA_MODE_ENABLED()) {
        QEMU_QXL_EXIT_VGA_MODE(qid);
    }
}

static inline void trace_qxl_hard_reset(int qid, int64_t loadvm) {
    if (QEMU_QXL_HARD_RESET_ENABLED()) {
        QEMU_QXL_HARD_RESET(qid, loadvm);
    }
}

static inline void trace_qxl_interface_async_complete_io(int qid, uint32_t current_async, void *cookie) {
    if (QEMU_QXL_INTERFACE_ASYNC_COMPLETE_IO_ENABLED()) {
        QEMU_QXL_INTERFACE_ASYNC_COMPLETE_IO(qid, current_async, cookie);
    }
}

static inline void trace_qxl_interface_attach_worker(int qid) {
    if (QEMU_QXL_INTERFACE_ATTACH_WORKER_ENABLED()) {
        QEMU_QXL_INTERFACE_ATTACH_WORKER(qid);
    }
}

static inline void trace_qxl_interface_get_init_info(int qid) {
    if (QEMU_QXL_INTERFACE_GET_INIT_INFO_ENABLED()) {
        QEMU_QXL_INTERFACE_GET_INIT_INFO(qid);
    }
}

static inline void trace_qxl_interface_set_compression_level(int qid, int64_t level) {
    if (QEMU_QXL_INTERFACE_SET_COMPRESSION_LEVEL_ENABLED()) {
        QEMU_QXL_INTERFACE_SET_COMPRESSION_LEVEL(qid, level);
    }
}

static inline void trace_qxl_interface_update_area_complete(int qid, uint32_t surface_id, uint32_t dirty_left, uint32_t dirty_right, uint32_t dirty_top, uint32_t dirty_bottom) {
    if (QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_ENABLED()) {
        QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE(qid, surface_id, dirty_left, dirty_right, dirty_top, dirty_bottom);
    }
}

static inline void trace_qxl_interface_update_area_complete_rest(int qid, uint32_t num_updated_rects) {
    if (QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_REST_ENABLED()) {
        QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_REST(qid, num_updated_rects);
    }
}

static inline void trace_qxl_interface_update_area_complete_overflow(int qid, int max) {
    if (QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_OVERFLOW_ENABLED()) {
        QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_OVERFLOW(qid, max);
    }
}

static inline void trace_qxl_interface_update_area_complete_schedule_bh(int qid, uint32_t num_dirty) {
    if (QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_SCHEDULE_BH_ENABLED()) {
        QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_SCHEDULE_BH(qid, num_dirty);
    }
}

static inline void trace_qxl_io_destroy_primary_ignored(int qid, const char *mode) {
    if (QEMU_QXL_IO_DESTROY_PRIMARY_IGNORED_ENABLED()) {
        QEMU_QXL_IO_DESTROY_PRIMARY_IGNORED(qid, mode);
    }
}

static inline void trace_qxl_io_read_unexpected(int qid) {
    if (QEMU_QXL_IO_READ_UNEXPECTED_ENABLED()) {
        QEMU_QXL_IO_READ_UNEXPECTED(qid);
    }
}

static inline void trace_qxl_io_unexpected_vga_mode(int qid, uint32_t io_port, const char *desc) {
    if (QEMU_QXL_IO_UNEXPECTED_VGA_MODE_ENABLED()) {
        QEMU_QXL_IO_UNEXPECTED_VGA_MODE(qid, io_port, desc);
    }
}

static inline void trace_qxl_io_write(int qid, const char *mode, uint64_t addr, uint64_t val, int async) {
    if (QEMU_QXL_IO_WRITE_ENABLED()) {
        QEMU_QXL_IO_WRITE(qid, mode, addr, val, async);
    }
}

static inline void trace_qxl_memslot_add_guest(int qid, uint32_t slot_id, uint64_t guest_start, uint64_t guest_end) {
    if (QEMU_QXL_MEMSLOT_ADD_GUEST_ENABLED()) {
        QEMU_QXL_MEMSLOT_ADD_GUEST(qid, slot_id, guest_start, guest_end);
    }
}

static inline void trace_qxl_post_load(int qid, const char *mode) {
    if (QEMU_QXL_POST_LOAD_ENABLED()) {
        QEMU_QXL_POST_LOAD(qid, mode);
    }
}

static inline void trace_qxl_pre_load(int qid) {
    if (QEMU_QXL_PRE_LOAD_ENABLED()) {
        QEMU_QXL_PRE_LOAD(qid);
    }
}

static inline void trace_qxl_pre_save(int qid) {
    if (QEMU_QXL_PRE_SAVE_ENABLED()) {
        QEMU_QXL_PRE_SAVE(qid);
    }
}

static inline void trace_qxl_reset_surfaces(int qid) {
    if (QEMU_QXL_RESET_SURFACES_ENABLED()) {
        QEMU_QXL_RESET_SURFACES(qid);
    }
}

static inline void trace_qxl_ring_command_check(int qid, const char *mode) {
    if (QEMU_QXL_RING_COMMAND_CHECK_ENABLED()) {
        QEMU_QXL_RING_COMMAND_CHECK(qid, mode);
    }
}

static inline void trace_qxl_ring_command_get(int qid, const char *mode) {
    if (QEMU_QXL_RING_COMMAND_GET_ENABLED()) {
        QEMU_QXL_RING_COMMAND_GET(qid, mode);
    }
}

static inline void trace_qxl_ring_command_req_notification(int qid) {
    if (QEMU_QXL_RING_COMMAND_REQ_NOTIFICATION_ENABLED()) {
        QEMU_QXL_RING_COMMAND_REQ_NOTIFICATION(qid);
    }
}

static inline void trace_qxl_ring_cursor_check(int qid, const char *mode) {
    if (QEMU_QXL_RING_CURSOR_CHECK_ENABLED()) {
        QEMU_QXL_RING_CURSOR_CHECK(qid, mode);
    }
}

static inline void trace_qxl_ring_cursor_get(int qid, const char *mode) {
    if (QEMU_QXL_RING_CURSOR_GET_ENABLED()) {
        QEMU_QXL_RING_CURSOR_GET(qid, mode);
    }
}

static inline void trace_qxl_ring_cursor_req_notification(int qid) {
    if (QEMU_QXL_RING_CURSOR_REQ_NOTIFICATION_ENABLED()) {
        QEMU_QXL_RING_CURSOR_REQ_NOTIFICATION(qid);
    }
}

static inline void trace_qxl_ring_res_push(int qid, const char *mode, uint32_t surface_count, uint32_t free_res, void *last_release, const char *notify) {
    if (QEMU_QXL_RING_RES_PUSH_ENABLED()) {
        QEMU_QXL_RING_RES_PUSH(qid, mode, surface_count, free_res, last_release, notify);
    }
}

static inline void trace_qxl_ring_res_push_rest(int qid, uint32_t ring_has, uint32_t ring_size, uint32_t prod, uint32_t cons) {
    if (QEMU_QXL_RING_RES_PUSH_REST_ENABLED()) {
        QEMU_QXL_RING_RES_PUSH_REST(qid, ring_has, ring_size, prod, cons);
    }
}

static inline void trace_qxl_ring_res_put(int qid, uint32_t free_res) {
    if (QEMU_QXL_RING_RES_PUT_ENABLED()) {
        QEMU_QXL_RING_RES_PUT(qid, free_res);
    }
}

static inline void trace_qxl_set_mode(int qid, int modenr, uint32_t x_res, uint32_t y_res, uint32_t bits, uint64_t devmem) {
    if (QEMU_QXL_SET_MODE_ENABLED()) {
        QEMU_QXL_SET_MODE(qid, modenr, x_res, y_res, bits, devmem);
    }
}

static inline void trace_qxl_soft_reset(int qid) {
    if (QEMU_QXL_SOFT_RESET_ENABLED()) {
        QEMU_QXL_SOFT_RESET(qid);
    }
}

static inline void trace_qemu_spice_add_memslot(int qid, uint32_t slot_id, unsigned long virt_start, unsigned long virt_end, int async) {
    if (QEMU_QEMU_SPICE_ADD_MEMSLOT_ENABLED()) {
        QEMU_QEMU_SPICE_ADD_MEMSLOT(qid, slot_id, virt_start, virt_end, async);
    }
}

static inline void trace_qemu_spice_del_memslot(int qid, uint32_t gid, uint32_t slot_id) {
    if (QEMU_QEMU_SPICE_DEL_MEMSLOT_ENABLED()) {
        QEMU_QEMU_SPICE_DEL_MEMSLOT(qid, gid, slot_id);
    }
}

static inline void trace_qemu_spice_create_primary_surface(int qid, uint32_t sid, void *surface, int async) {
    if (QEMU_QEMU_SPICE_CREATE_PRIMARY_SURFACE_ENABLED()) {
        QEMU_QEMU_SPICE_CREATE_PRIMARY_SURFACE(qid, sid, surface, async);
    }
}

static inline void trace_qemu_spice_destroy_primary_surface(int qid, uint32_t sid, int async) {
    if (QEMU_QEMU_SPICE_DESTROY_PRIMARY_SURFACE_ENABLED()) {
        QEMU_QEMU_SPICE_DESTROY_PRIMARY_SURFACE(qid, sid, async);
    }
}

static inline void trace_qemu_spice_wakeup(uint32_t qid) {
    if (QEMU_QEMU_SPICE_WAKEUP_ENABLED()) {
        QEMU_QEMU_SPICE_WAKEUP(qid);
    }
}

static inline void trace_qemu_spice_start(uint32_t qid) {
    if (QEMU_QEMU_SPICE_START_ENABLED()) {
        QEMU_QEMU_SPICE_START(qid);
    }
}

static inline void trace_qemu_spice_stop(uint32_t qid) {
    if (QEMU_QEMU_SPICE_STOP_ENABLED()) {
        QEMU_QEMU_SPICE_STOP(qid);
    }
}

static inline void trace_qemu_spice_create_update(uint32_t left, uint32_t right, uint32_t top, uint32_t bottom) {
    if (QEMU_QEMU_SPICE_CREATE_UPDATE_ENABLED()) {
        QEMU_QEMU_SPICE_CREATE_UPDATE(left, right, top, bottom);
    }
}

static inline void trace_qxl_spice_destroy_surfaces_complete(int qid) {
    if (QEMU_QXL_SPICE_DESTROY_SURFACES_COMPLETE_ENABLED()) {
        QEMU_QXL_SPICE_DESTROY_SURFACES_COMPLETE(qid);
    }
}

static inline void trace_qxl_spice_destroy_surfaces(int qid, int async) {
    if (QEMU_QXL_SPICE_DESTROY_SURFACES_ENABLED()) {
        QEMU_QXL_SPICE_DESTROY_SURFACES(qid, async);
    }
}

static inline void trace_qxl_spice_destroy_surface_wait_complete(int qid, uint32_t id) {
    if (QEMU_QXL_SPICE_DESTROY_SURFACE_WAIT_COMPLETE_ENABLED()) {
        QEMU_QXL_SPICE_DESTROY_SURFACE_WAIT_COMPLETE(qid, id);
    }
}

static inline void trace_qxl_spice_destroy_surface_wait(int qid, uint32_t id, int async) {
    if (QEMU_QXL_SPICE_DESTROY_SURFACE_WAIT_ENABLED()) {
        QEMU_QXL_SPICE_DESTROY_SURFACE_WAIT(qid, id, async);
    }
}

static inline void trace_qxl_spice_flush_surfaces_async(int qid, uint32_t surface_count, uint32_t num_free_res) {
    if (QEMU_QXL_SPICE_FLUSH_SURFACES_ASYNC_ENABLED()) {
        QEMU_QXL_SPICE_FLUSH_SURFACES_ASYNC(qid, surface_count, num_free_res);
    }
}

static inline void trace_qxl_spice_monitors_config(int id) {
    if (QEMU_QXL_SPICE_MONITORS_CONFIG_ENABLED()) {
        QEMU_QXL_SPICE_MONITORS_CONFIG(id);
    }
}

static inline void trace_qxl_spice_loadvm_commands(int qid, void *ext, uint32_t count) {
    if (QEMU_QXL_SPICE_LOADVM_COMMANDS_ENABLED()) {
        QEMU_QXL_SPICE_LOADVM_COMMANDS(qid, ext, count);
    }
}

static inline void trace_qxl_spice_oom(int qid) {
    if (QEMU_QXL_SPICE_OOM_ENABLED()) {
        QEMU_QXL_SPICE_OOM(qid);
    }
}

static inline void trace_qxl_spice_reset_cursor(int qid) {
    if (QEMU_QXL_SPICE_RESET_CURSOR_ENABLED()) {
        QEMU_QXL_SPICE_RESET_CURSOR(qid);
    }
}

static inline void trace_qxl_spice_reset_image_cache(int qid) {
    if (QEMU_QXL_SPICE_RESET_IMAGE_CACHE_ENABLED()) {
        QEMU_QXL_SPICE_RESET_IMAGE_CACHE(qid);
    }
}

static inline void trace_qxl_spice_reset_memslots(int qid) {
    if (QEMU_QXL_SPICE_RESET_MEMSLOTS_ENABLED()) {
        QEMU_QXL_SPICE_RESET_MEMSLOTS(qid);
    }
}

static inline void trace_qxl_spice_update_area(int qid, uint32_t surface_id, uint32_t left, uint32_t right, uint32_t top, uint32_t bottom) {
    if (QEMU_QXL_SPICE_UPDATE_AREA_ENABLED()) {
        QEMU_QXL_SPICE_UPDATE_AREA(qid, surface_id, left, right, top, bottom);
    }
}

static inline void trace_qxl_spice_update_area_rest(int qid, uint32_t num_dirty_rects, uint32_t clear_dirty_region) {
    if (QEMU_QXL_SPICE_UPDATE_AREA_REST_ENABLED()) {
        QEMU_QXL_SPICE_UPDATE_AREA_REST(qid, num_dirty_rects, clear_dirty_region);
    }
}

static inline void trace_qxl_surfaces_dirty(int qid, int surface, int addr, int offset, int size) {
    if (QEMU_QXL_SURFACES_DIRTY_ENABLED()) {
        QEMU_QXL_SURFACES_DIRTY(qid, surface, addr, offset, size);
    }
}

static inline void trace_qxl_set_client_capabilities_unsupported_by_revision(int qid, int revision) {
    if (QEMU_QXL_SET_CLIENT_CAPABILITIES_UNSUPPORTED_BY_REVISION_ENABLED()) {
        QEMU_QXL_SET_CLIENT_CAPABILITIES_UNSUPPORTED_BY_REVISION(qid, revision);
    }
}

static inline void trace_qxl_interrupt_client_monitors_config(int qid, int num_heads, void *heads) {
    if (QEMU_QXL_INTERRUPT_CLIENT_MONITORS_CONFIG_ENABLED()) {
        QEMU_QXL_INTERRUPT_CLIENT_MONITORS_CONFIG(qid, num_heads, heads);
    }
}

static inline void trace_qxl_client_monitors_config_unsupported_by_guest(int qid, uint32_t int_mask, void *client_monitors_config) {
    if (QEMU_QXL_CLIENT_MONITORS_CONFIG_UNSUPPORTED_BY_GUEST_ENABLED()) {
        QEMU_QXL_CLIENT_MONITORS_CONFIG_UNSUPPORTED_BY_GUEST(qid, int_mask, client_monitors_config);
    }
}

static inline void trace_qxl_client_monitors_config_capped(int qid, int requested, int limit) {
    if (QEMU_QXL_CLIENT_MONITORS_CONFIG_CAPPED_ENABLED()) {
        QEMU_QXL_CLIENT_MONITORS_CONFIG_CAPPED(qid, requested, limit);
    }
}

static inline void trace_qxl_client_monitors_config_crc(int qid, unsigned size, uint32_t crc32) {
    if (QEMU_QXL_CLIENT_MONITORS_CONFIG_CRC_ENABLED()) {
        QEMU_QXL_CLIENT_MONITORS_CONFIG_CRC(qid, size, crc32);
    }
}

static inline void trace_qxl_render_blit_guest_primary_initialized(void) {
    if (QEMU_QXL_RENDER_BLIT_GUEST_PRIMARY_INITIALIZED_ENABLED()) {
        QEMU_QXL_RENDER_BLIT_GUEST_PRIMARY_INITIALIZED();
    }
}

static inline void trace_qxl_render_blit(int32_t stride, int32_t left, int32_t right, int32_t top, int32_t bottom) {
    if (QEMU_QXL_RENDER_BLIT_ENABLED()) {
        QEMU_QXL_RENDER_BLIT(stride, left, right, top, bottom);
    }
}

static inline void trace_qxl_render_guest_primary_resized(int32_t width, int32_t height, int32_t stride, int32_t bytes_pp, int32_t bits_pp) {
    if (QEMU_QXL_RENDER_GUEST_PRIMARY_RESIZED_ENABLED()) {
        QEMU_QXL_RENDER_GUEST_PRIMARY_RESIZED(width, height, stride, bytes_pp, bits_pp);
    }
}

static inline void trace_qxl_render_update_area_done(void *cookie) {
    if (QEMU_QXL_RENDER_UPDATE_AREA_DONE_ENABLED()) {
        QEMU_QXL_RENDER_UPDATE_AREA_DONE(cookie);
    }
}

static inline void trace_handle_qmp_command(void *mon, const char *cmd_name) {
    if (QEMU_HANDLE_QMP_COMMAND_ENABLED()) {
        QEMU_HANDLE_QMP_COMMAND(mon, cmd_name);
    }
}

static inline void trace_monitor_protocol_emitter(void *mon) {
    if (QEMU_MONITOR_PROTOCOL_EMITTER_ENABLED()) {
        QEMU_MONITOR_PROTOCOL_EMITTER(mon);
    }
}

static inline void trace_monitor_protocol_event(uint32_t event, const char *evname, void *data) {
    if (QEMU_MONITOR_PROTOCOL_EVENT_ENABLED()) {
        QEMU_MONITOR_PROTOCOL_EVENT(event, evname, data);
    }
}

static inline void trace_monitor_protocol_event_handler(uint32_t event, void *data, uint64_t last, uint64_t now) {
    if (QEMU_MONITOR_PROTOCOL_EVENT_HANDLER_ENABLED()) {
        QEMU_MONITOR_PROTOCOL_EVENT_HANDLER(event, data, last, now);
    }
}

static inline void trace_monitor_protocol_event_emit(uint32_t event, void *data) {
    if (QEMU_MONITOR_PROTOCOL_EVENT_EMIT_ENABLED()) {
        QEMU_MONITOR_PROTOCOL_EVENT_EMIT(event, data);
    }
}

static inline void trace_monitor_protocol_event_queue(uint32_t event, void *data, uint64_t rate, uint64_t last, uint64_t now) {
    if (QEMU_MONITOR_PROTOCOL_EVENT_QUEUE_ENABLED()) {
        QEMU_MONITOR_PROTOCOL_EVENT_QUEUE(event, data, rate, last, now);
    }
}

static inline void trace_monitor_protocol_event_throttle(uint32_t event, uint64_t rate) {
    if (QEMU_MONITOR_PROTOCOL_EVENT_THROTTLE_ENABLED()) {
        QEMU_MONITOR_PROTOCOL_EVENT_THROTTLE(event, rate);
    }
}

static inline void trace_hbitmap_iter_skip_words(const void *hb, void *hbi, uint64_t pos, unsigned long cur) {
    if (QEMU_HBITMAP_ITER_SKIP_WORDS_ENABLED()) {
        QEMU_HBITMAP_ITER_SKIP_WORDS(hb, hbi, pos, cur);
    }
}

static inline void trace_hbitmap_reset(void *hb, uint64_t start, uint64_t count, uint64_t sbit, uint64_t ebit) {
    if (QEMU_HBITMAP_RESET_ENABLED()) {
        QEMU_HBITMAP_RESET(hb, start, count, sbit, ebit);
    }
}

static inline void trace_hbitmap_set(void *hb, uint64_t start, uint64_t count, uint64_t sbit, uint64_t ebit) {
    if (QEMU_HBITMAP_SET_ENABLED()) {
        QEMU_HBITMAP_SET(hb, start, count, sbit, ebit);
    }
}

static inline void trace_migrate_set_state(int new_state) {
    if (QEMU_MIGRATE_SET_STATE_ENABLED()) {
        QEMU_MIGRATE_SET_STATE(new_state);
    }
}

static inline void trace_kvm_ioctl(int type, void *arg) {
    if (QEMU_KVM_IOCTL_ENABLED()) {
        QEMU_KVM_IOCTL(type, arg);
    }
}

static inline void trace_kvm_vm_ioctl(int type, void *arg) {
    if (QEMU_KVM_VM_IOCTL_ENABLED()) {
        QEMU_KVM_VM_IOCTL(type, arg);
    }
}

static inline void trace_kvm_vcpu_ioctl(int cpu_index, int type, void *arg) {
    if (QEMU_KVM_VCPU_IOCTL_ENABLED()) {
        QEMU_KVM_VCPU_IOCTL(cpu_index, type, arg);
    }
}

static inline void trace_kvm_run_exit(int cpu_index, uint32_t reason) {
    if (QEMU_KVM_RUN_EXIT_ENABLED()) {
        QEMU_KVM_RUN_EXIT(cpu_index, reason);
    }
}

static inline void trace_object_dynamic_cast_assert(const char *type, const char *target, const char *file, int line, const char *func) {
    if (QEMU_OBJECT_DYNAMIC_CAST_ASSERT_ENABLED()) {
        QEMU_OBJECT_DYNAMIC_CAST_ASSERT(type, target, file, line, func);
    }
}

static inline void trace_object_class_dynamic_cast_assert(const char *type, const char *target, const char *file, int line, const char *func) {
    if (QEMU_OBJECT_CLASS_DYNAMIC_CAST_ASSERT_ENABLED()) {
        QEMU_OBJECT_CLASS_DYNAMIC_CAST_ASSERT(type, target, file, line, func);
    }
}

#endif /* TRACE_H */
